﻿using System;
using System.IO;
using System.Text;
using System.Reflection;
using System.Collections.Generic;
using System.Threading;
using System.Data;
using System.Text.RegularExpressions;

using PRoCon.Core;
using PRoCon.Core.Plugin;
using PRoCon.Core.Plugin.Commands;
using PRoCon.Core.Players;
using PRoCon.Core.Players.Items;

namespace PRoConEvents
{
    public class EndOfRoundStats : PRoConPluginAPI, IPRoConPluginInterface3
    {
        #region Plugin variable declarations and assignments

        private float m_fBestKillstreak;

        private int m_iMostDeaths;
        private string m_strBestKillstreak;
        private string m_strFirstBlood;
        private string m_strFirstKnife;
        private string m_strLastBlood;
        private string m_strLastKnife;
        private string m_strMostDeaths;
		private float m_fBestKDR;
		private string m_strBestKDR;
        private string m_strMVP;
        private int m_iMVP;

		
        private float m_fLastBestKillstreak;

		
		private int m_iLastMostDeaths;
        private string m_strLastBestKillstreak;
        private string m_strLastFirstBlood;
        private string m_strLastFirstKnife;
        private string m_strLastLastBlood;
        private string m_strLastLastKnife;
        private string m_strLastMostDeaths;
		private float m_fLastBestKDR;
		private string m_strLastBestKDR;
        private string m_strLastMVP;


		private bool m_bFirstSpawn;
        public float m_fKDR;
		
		
		private bool m_isPluginEnabled;
		
        public EndOfRoundStats()
        {
            this.m_fBestKillstreak = 0F;
            this.m_iMostDeaths = 0;
            this.m_strBestKillstreak = "Nobody!";
            this.m_strFirstBlood = "Nobody!";
            this.m_strFirstKnife = "Nobody!";
            this.m_strLastBlood = "Nobody!";
            this.m_strLastKnife = "Nobody!";
            this.m_strMostDeaths = "Nobody!";
            this.m_strMVP = "Nobody!";
            this.m_iMVP = 0;

			
			this.m_fLastBestKillstreak = 0F;
			this.m_iLastMostDeaths = 0;
			this.m_strLastBestKillstreak = "Nobody!";
			this.m_strLastFirstBlood = "Nobody!";
			this.m_strLastFirstKnife = "Nobody!";
			this.m_strLastLastBlood = "Nobody!";
			this.m_strLastLastKnife = "Nobody!";
			this.m_strLastMostDeaths = "Nobody!";
            this.m_strLastMVP = "Nobody!";

			
			this.m_bFirstSpawn = false;
			this.m_isPluginEnabled = false;
        }
        #endregion

        #region Plugin information

        public string GetPluginName()
        {
            return "End of Round Stats BF3 ";
        }

        public string GetPluginVersion()
        {
            return "v0.05";
        }

        public string GetPluginAuthor()
        {
            return "blactionhero (Updated for BF3 by Fruity)";
        }

        public string GetPluginWebsite()
        {
            return "www.phogue.net/";
        }

        public string GetPluginDescription()
        {
            return @"
			
<h2><u>Description</u></h2>

<p>End of Round Stats displays the following info in the chatbox at the end of each round: Best KDR, Most Deaths, First Blood, First Knife, Last Blood, and Last Knife.

";
        }

        #endregion

        #region PRoCon variables

        public void OnPluginLoaded(string strHostName, string strPort, string strPRoConVersion)
        {
            this.RegisterEvents(this.GetType().Name, "OnPluginEnable", /*"OnServerInfo",*/ "OnListPlayers", "OnPlayerKilled", "OnRoundOver", "OnPlayerSpawned", "OnPluginDisable");
        }

        public List<CPluginVariable> GetDisplayPluginVariables()
        {
            List<CPluginVariable> lstReturn = new List<CPluginVariable>();
            return lstReturn;
        }

        public List<CPluginVariable> GetPluginVariables()
        {
            List<CPluginVariable> lstReturn = new List<CPluginVariable>();
            return lstReturn;
        }

        public void SetPluginVariable(string strVariable, string strValue)
        {
        }

        #endregion

        #region PRoCon events

        public void OnPluginEnable() 
		{ 
			this.ExecuteCommand("procon.protected.pluginconsole.write", "^bEnd of Round Stats: ^2Enabled!");
			this.m_isPluginEnabled = true;
			this.RegisterAllCommands();
		}

		
		public void ResetStats()
		{
            m_fBestKillstreak = 0F;
            m_iMostDeaths = 0;
            m_strBestKillstreak = "Nobody!";
            m_strFirstBlood = "Nobody!";
            m_strFirstKnife = "Nobody!";
            m_strLastBlood = "Nobody!";
            m_strLastKnife = "Nobody!";
            m_strMostDeaths = "Nobody!";
			m_fBestKDR = 0F;
			m_strBestKDR = "Nobody!";
            m_strMVP = "Nobody!";
            m_iMVP = 0;
			
			this.m_bFirstSpawn = false;
        }
		
		public void SayLastStats()
		{
            this.ExecuteCommand("procon.protected.pluginconsole.write", "^bRound Stats^n: Last Round stats said");
			
			this.ExecuteCommand("procon.protected.send", "admin.say", "End of Round Stats - Previous round:", "all");
            this.ExecuteCommand("procon.protected.send", "admin.say", "First Blood: " + m_strLastFirstBlood + ", First Knife: " + m_strLastFirstKnife, "all");
            this.ExecuteCommand("procon.protected.send", "admin.say", "Last Blood: " + m_strLastLastBlood + ", Last Knife: " + m_strLastLastKnife, "all");
            this.ExecuteCommand("procon.protected.send", "admin.say", "Best Killstreak: " + m_strLastBestKillstreak + " (" + m_fLastBestKillstreak.ToString() + "), Most Deaths: " + m_strLastMostDeaths + " (" + m_iLastMostDeaths.ToString() + " lol)", "all");
			this.ExecuteCommand("procon.protected.send", "admin.say", "Best KDR: " + m_strLastBestKDR + "(" + m_fLastBestKDR + "), MVP: " + m_strLastMVP,"all");
			
			this.ExecuteCommand("procon.protected.pluginconsole.write", "End of Round Stats - Previous round:", "all");
            this.ExecuteCommand("procon.protected.pluginconsole.write", "First Blood: " + m_strLastFirstBlood + ", First Knife: " + m_strLastFirstKnife, "all");
            this.ExecuteCommand("procon.protected.pluginconsole.write", "Last Blood: " + m_strLastLastBlood + ", Last Knife: " + m_strLastLastKnife, "all");
            this.ExecuteCommand("procon.protected.pluginconsole.write", "Best Killstreak: " + m_strLastBestKillstreak + " (" + m_fLastBestKillstreak.ToString() + "), Most Deaths: " + m_strLastMostDeaths + " (" + m_iLastMostDeaths.ToString() + " lol)", "all");
			this.ExecuteCommand("procon.protected.pluginconsole.write", "Best KDR: " + m_strLastBestKDR + "(" + m_fLastBestKDR + "), MVP: " + m_strLastMVP,"all");
		}

		public void SayCurrStats()
		{
            this.ExecuteCommand("procon.protected.pluginconsole.write", "^bRound Stats^n: Current Round stats said");
			
			this.ExecuteCommand("procon.protected.send", "admin.say", "Round Stats - Current round:", "all");
            this.ExecuteCommand("procon.protected.send", "admin.say", "First Blood: " + m_strFirstBlood + ", First Knife: " + m_strFirstKnife, "all");
            this.ExecuteCommand("procon.protected.send", "admin.say", "Latest Kill: " + m_strLastBlood + ", Latest Knife: " + m_strLastKnife, "all");
            this.ExecuteCommand("procon.protected.send", "admin.say", "Best Killstreak so far: " + m_strBestKillstreak + " (" + m_fBestKillstreak.ToString() + "), Most Deaths so far: " + m_strMostDeaths + " (" + m_iMostDeaths.ToString() + " lol)", "all");
			this.ExecuteCommand("procon.protected.send", "admin.say", "Best KDR: " + m_strBestKDR + "(" + m_fBestKDR + "), MVP: " + m_strMVP,"all");
			
			this.ExecuteCommand("procon.protected.pluginconsole.write", "Round Stats - Current round:", "all");
            this.ExecuteCommand("procon.protected.pluginconsole.write", "First Blood: " + m_strFirstBlood + ", First Knife: " + m_strFirstKnife, "all");
            this.ExecuteCommand("procon.protected.pluginconsole.write", "Latest Kill: " + m_strLastBlood + ", Latest Knife: " + m_strLastKnife, "all");
            this.ExecuteCommand("procon.protected.pluginconsole.write", "Best Killstreak so far: " + m_strBestKillstreak + " (" + m_fBestKillstreak.ToString() + "), Most Deaths so far: " + m_strMostDeaths + " (" + m_iMostDeaths.ToString() + " lol)", "all");
			this.ExecuteCommand("procon.protected.pluginconsole.write", "Best KDR: " + m_strBestKDR + "(" + m_fBestKDR + "), MVP: " + m_strMVP,"all");
		}

        public void OnPluginDisable()
        {
            SayCurrStats();
			this.ExecuteCommand("procon.protected.pluginconsole.write", "^bEnd of Round Stats: ^1Disabled =(");
			this.UnregisterAllCommands();
			this.m_isPluginEnabled = false;
        }

		private void UnregisterAllCommands() {
            this.UnregisterCommand(new MatchCommand("EndOfRoundStats", "OnCommandLastRoundStats", this.Listify<string>("@", "!", "#"), "lastroundstats", this.Listify<MatchArgumentFormat>(), new ExecutionRequirements(ExecutionScope.All), "Displays the last round stats"));
            this.UnregisterCommand(new MatchCommand("EndOfRoundStats", "OnCommandRoundStats", this.Listify<string>("@", "!", "#"), "roundstats", this.Listify<MatchArgumentFormat>(), new ExecutionRequirements(ExecutionScope.All), "Says current round stats"));
        }

        private void RegisterAllCommands() {

            if (this.m_isPluginEnabled == true) {
                this.RegisterCommand(new MatchCommand("EndOfRoundStats", "OnCommandLastRoundStats", this.Listify<string>("@", "!", "#"), "lastroundstats", this.Listify<MatchArgumentFormat>(), new ExecutionRequirements(ExecutionScope.All), "Displays the last round stats"));
				this.RegisterCommand(new MatchCommand("EndOfRoundStats", "OnCommandRoundStats", this.Listify<string>("@", "!", "#"), "roundstats", this.Listify<MatchArgumentFormat>(), new ExecutionRequirements(ExecutionScope.All), "Says current round stats"));
            }
        }

		private List<string> GetExcludedCommandStrings(string strAccountName) {

            List<string> lstReturnCommandStrings = new List<string>();

            List<MatchCommand> lstCommands = this.GetRegisteredCommands();

            CPrivileges privileges = this.GetAccountPrivileges(strAccountName);

            foreach (MatchCommand mtcCommand in lstCommands) {

                if (mtcCommand.Requirements.HasValidPermissions(privileges) == true && lstReturnCommandStrings.Contains(mtcCommand.Command) == false) {
                    lstReturnCommandStrings.Add(mtcCommand.Command);
                }
            }

            return lstReturnCommandStrings;
        }

        private List<string> GetCommandStrings() {

            List<string> lstReturnCommandStrings = new List<string>();

            List<MatchCommand> lstCommands = this.GetRegisteredCommands();

            foreach (MatchCommand mtcCommand in lstCommands) {

                if (lstReturnCommandStrings.Contains(mtcCommand.Command) == false) {
                    lstReturnCommandStrings.Add(mtcCommand.Command);
                }
            }

            return lstReturnCommandStrings;
        }
		

		
		public void OnCommandLastRoundStats(string strSpeaker, string strText, MatchCommand mtcCommand, CapturedCommand capCommand, CPlayerSubset subMatchedScope) 
		{
			this.ExecuteCommand("procon.protected.pluginconsole.write", "^bRound Stats^n: Last Round stats requested");
			SayLastStats();
		}
		
		public void OnCommandRoundStats(string strSpeaker, string strText, MatchCommand mtcCommand, CapturedCommand capCommand, CPlayerSubset subMatchedScope) 
		{
			this.ExecuteCommand("procon.protected.pluginconsole.write", "^bRound Stats^n: Current Round stats requested");
			this.ExecuteCommand("procon.protected.send", "admin.listPlayers", "all");
			this.ExecuteCommand("procon.protected.send", "serverInfo");
				Thread delayed = new Thread(new ThreadStart(delegate()
				{
								int X = 3;
								Thread.Sleep(X * 1000);
								SayCurrStats();
				}));
                delayed.Start();
		}		
		
        public void OnRoundOver(int iWinningTeamID)
        {
            this.ExecuteCommand("procon.protected.pluginconsole.write", "^bRound Stats^n: Round declared as over");
			
			this.ExecuteCommand("procon.protected.send", "admin.listPlayers", "all");
			this.ExecuteCommand("procon.protected.send", "serverInfo");

            m_fLastBestKillstreak = m_fBestKillstreak;
			m_iLastMostDeaths = m_iMostDeaths;
			m_strLastBestKillstreak = m_strBestKillstreak;
			m_strLastFirstBlood = m_strFirstBlood;
			m_strLastFirstKnife = m_strFirstKnife;
			m_strLastLastBlood = m_strLastBlood;
			m_strLastLastKnife = m_strLastKnife;
			m_strLastMostDeaths = m_strMostDeaths;
			m_fLastBestKDR = m_fBestKDR;
			m_strLastBestKDR = m_strBestKDR;
            m_strLastMVP = m_strMVP;
			
			ResetStats();
			
			// SayCurrStats(); // Would print to the chat the scores for the last millisecond
			
			this.m_bFirstSpawn = false;
			
        }

        public void OnListPlayers(List<CPlayerInfo> lstPlayers, CPlayerSubset cpsSubset)
        {
            if (cpsSubset.Subset == CPlayerSubset.PlayerSubsetType.All)
            {
                foreach (CPlayerInfo cpiPlayer in lstPlayers)
                {
                   
					if (cpiPlayer.Deaths == 0)
					{
					m_fKDR = cpiPlayer.Kills;
					}
					
                    if (cpiPlayer.Deaths != 0)
					{
						m_fKDR = (cpiPlayer.Kills / cpiPlayer.Deaths);
					}

                    if (cpiPlayer.Score > m_iMVP)
                    {
                        m_iMVP = cpiPlayer.Score;
                        m_strMVP = cpiPlayer.SoldierName;
                    }

					if (m_fKDR > m_fBestKDR)
					{
						m_fBestKDR = m_fKDR;
						m_strBestKDR = cpiPlayer.SoldierName;
					}
					
					if (cpiPlayer.Kdr > m_fBestKillstreak)
                    {
                        m_fBestKillstreak = cpiPlayer.Kdr;
                        m_strBestKillstreak = cpiPlayer.SoldierName;
                    }

                    if (cpiPlayer.Deaths > m_iMostDeaths)
                    {
                        m_iMostDeaths = cpiPlayer.Deaths;
                        m_strMostDeaths = cpiPlayer.SoldierName;
                    }
                }
            }
        }

        public virtual void OnPlayerSpawned(string soldierName, Inventory spawnedInventory) 
		{
			if (this.m_bFirstSpawn == false)
			{
				this.ExecuteCommand("procon.protected.pluginconsole.write", "^bRound Stats^n: First player to spawn this round");
				this.m_bFirstSpawn = true;
				// Waits 10 seconds after the first person has spawned before saying last round stats
				Thread delayed = new Thread(new ThreadStart(delegate()
				{
								int X = 10;
								Thread.Sleep(X * 1000);
								SayLastStats();
				}));
                delayed.Start();
			}
		}
		
		public void OnPlayerKilled(Kill kKillerVictimDetails)
        {
            Weapon weaponUsed = this.GetWeaponDefines()[kKillerVictimDetails.DamageType];
            string weaponUsedName = this.GetLocalized(weaponUsed.Name, String.Format("global.Weapons.{0}", kKillerVictimDetails.DamageType.ToLower()));
            CPlayerInfo Killer = kKillerVictimDetails.Killer;
			CPlayerInfo Victim = kKillerVictimDetails.Victim;
			
			if(Killer.SoldierName != Victim.SoldierName && Killer.TeamID != Victim.TeamID) //Not a suicide or a teamkill
			{
				m_strLastBlood = Killer.SoldierName; 

				if (kKillerVictimDetails.Headshot) 
				{
					
				}

				else
				{
					
				}

				if (m_strFirstBlood == "Nobody!")
				{
					m_strFirstBlood = Killer.SoldierName;
				}

				if (weaponUsedName == "Weapons/Knife/Knife" || weaponUsedName == "Melee" || weaponUsedName == "Knife")
				{
					m_strLastKnife = Killer.SoldierName;

					if (m_strFirstKnife == "Nobody!")
					{
						m_strFirstKnife = Killer.SoldierName;
					}
				}
			}
        }
		
		public void OnServerInfo(CServerInfo csiServerInfo)
		{
	        // Nothing here for the moment - will find a use eventually for roundtime or something on the todo list. ;-)
		}
		

	}
}
        #endregion